## xmlrpc-c 1.33.14

=== examples/Makefile ===
# Since the programs in this directory are examples for the user, this make
# file should be as ordinary as possible.  It should not rely heavily on
# included make files or configuration parameters.  Also, we don't try to
# build or rebuild the libraries on which these programs depend or even
# recognize that they've changed on their own.


ifeq ($(SRCDIR),)
SRCDIR = $(CURDIR)/..
BLDDIR = $(SRCDIR)
endif
SUBDIR = examples

include $(BLDDIR)/config.mk

default: all

CFLAGS += $(CFLAGS_PERSONAL) $(CADD)
LDFLAGS += $(LDFLAGS_PERSONAL) $(LADD)

# If this were a real application, working from an installed copy of
# Xmlrpc-c, XMLRPC_C_CONFIG would just be 'xmlrpc-c-config'.  It would be
# found in the user's PATH.
XMLRPC_C_CONFIG = $(BLDDIR)/xmlrpc-c-config.test

CLIENTPROGS = \
  auth_client \
  compound_value_client \
  synch_client \
  xmlrpc_sample_add_client \
  xmlrpc_asynch_client \

ifeq ($(MUST_BUILD_CURL_CLIENT),yes)
  ifneq ($(MSVCRT),yes)
    CLIENTPROGS += interrupted_client
  endif
endif

SERVERPROGS_CGI = \
  xmlrpc_sample_add_server.cgi

SERVERPROGS_ABYSS = \
  compound_value_server \
  xmlrpc_inetd_server \
  xmlrpc_socket_server \
  xmlrpc_loop_server \
  xmlrpc_sample_add_server \
  xmlrpc_server_validatee \

ifneq ($(MSVCRT),yes)
  SERVERPROGS_ABYSS += interrupted_server
endif

BASIC_PROGS = \
  json \
  gen_sample_add_xml \
  parse_xml \

# Build up PROGS:
PROGS = 

PROGS += $(BASIC_PROGS)

ifeq ($(ENABLE_ABYSS_SERVER),yes)
  PROGS += $(SERVERPROGS_ABYSS)
endif

ifeq ($(MUST_BUILD_CLIENT),yes)
  PROGS += $(CLIENTPROGS)
endif

ifeq ($(ENABLE_CGI_SERVER),yes)
  PROGS += $(SERVERPROGS_CGI) 
endif

INCLUDES = -I. $(shell $(XMLRPC_C_CONFIG) client abyss-server --cflags)

LIBS_CLIENT = \
  $(shell $(XMLRPC_C_CONFIG) client --libs)

LIBS_SERVER_ABYSS = \
  $(shell $(XMLRPC_C_CONFIG) abyss-server --libs)

LIBS_SERVER_CGI = \
  $(shell $(XMLRPC_C_CONFIG) cgi-server --libs)

LIBS_BASE = \
  $(shell $(XMLRPC_C_CONFIG) --libs)

all: $(PROGS)

ifeq ($(ENABLE_CPLUSPLUS),yes)
  all: cpp/all
endif

.PHONY: cpp/all
cpp/all: $(BLDDIR)/examples/cpp
	$(MAKE) -C cpp -f $(SRCDIR)/examples/cpp/Makefile all

# When building in separate tree, directory won't exist yet
$(BLDDIR)/examples/cpp:
	mkdir $@

$(CLIENTPROGS):%:%.o
	$(CCLD) -o $@ $^ $(LIBS_CLIENT) $(LDFLAGS)

$(SERVERPROGS_CGI):%.cgi:%_cgi.o
	$(CCLD) -o $@ $^ $(LIBS_SERVER_CGI) $(LDFLAGS)

$(SERVERPROGS_ABYSS):%:%.o
	$(CCLD) -o $@ $^ $(LIBS_SERVER_ABYSS) $(LDFLAGS)

$(BASIC_PROGS):%:%.o
	$(CCLD) -o $@ $^ $(LIBS_BASE) $(LDFLAGS) 


OBJECTS = $(patsubst %,%.o,$(patsubst %.cgi,%_cgi,$(PROGS)))

$(OBJECTS):%.o:%.c
	$(CC) -c $(INCLUDES) $(CFLAGS) $<

# config.h and xmlrpc_amconfig.h just describe the build environment.
# We use them so that the example programs will build in users'
# various environments.  If you're copying these examples, you can
# just remove these headers from the programs and hardcode whatever is
# right for your build environment.

$(OBJECTS): config.h xmlrpc_amconfig.h

config.h:
	$(LN_S) $(BLDDIR)/xmlrpc_config.h $@
xmlrpc_amconfig.h:
	$(LN_S) $(BLDDIR)/$@ .

.PHONY: clean
clean:
	rm -f $(PROGS) *.o config.h xmlrpc_amconfig.h
	$(MAKE) -C cpp clean

.PHONY: distclean
distclean: clean

BINDIR=$(DESTDIR)$(bindir)

FILENAME_GENERATOR = "echo $$p|sed 's/$(EXEEXT)$$//'|sed '$(transform)'|sed 's/$$/$(EXEEXT)/'"

INSTCMD =  "$(LIBTOOL) --mode=install $(INSTALL_PROGRAM) $$p \
  $(BINDIR)/`$(FILENAME_GENERATOR)`"

.PHONY: install
install: $(PROGS)
	@$(NORMAL_INSTALL)
	$(MKINSTALLDIRS) $(BINDIR)
	@list='$(bin_PROGRAMS)'; for p in $$list; do \
	  if test -f $$p; then \
	    echo "$(INSTCMD)"; $(INSTCMD); \
	  else :; \
          fi; \
	done

.PHONY: check
check:

.PHONY: dep depend
dep depend:
# We don't do dependencies in this directory, because it's supposed to be
# an example of what a program outside this package would do, so we can't
# go weaving it into the rest of the package.  Ergo, a developer must
# carefully clean and remake examples as he updates other parts of the tree.

=== include/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  SRCDIR := $(call updir,$(CURDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := include

include $(BLDDIR)/config.mk

default: all

all: xmlrpc-c/config.h

xmlrpc-c/config.h: $(BLDDIR)/$(SUBDIR)/xmlrpc-c
	>$@
	@echo "Lots of echoes to '$@' suppressed here ..."
	@echo '#ifndef XMLRPC_C_CONFIG_H_INCLUDED'                        >>$@
	@echo '#define XMLRPC_C_CONFIG_H_INCLUDED'                        >>$@
	@echo ''                                                          >>$@
	@echo '/* This file, part of XML-RPC For C/C++, is meant to '     >>$@
	@echo '   define characteristics of this particular installation '>>$@ 
	@echo '   that the other <xmlrpc-c/...> header files need in '    >>$@
	@echo '   order to compile correctly when #included in Xmlrpc-c'  >>$@
	@echo '   user code.'						  >>$@
	@echo ''                                                          >>$@
	@echo '   Those header files #include this one.'                  >>$@
	@echo ''                                                          >>$@
	@echo '   This file was created by a make rule.'                  >>$@
	@echo '*/'                                                        >>$@
	@echo '#define XMLRPC_HAVE_WCHAR $(HAVE_WCHAR_H_DEFINE)'          >>$@
	@echo '#ifdef _WIN32'                                             >>$@
	@echo '  /* SOCKET is a type defined by <winsock.h>.  Anyone who' >>$@
	@echo '     uses XMLRPC_SOCKET on a WIN32 system must #include'   >>$@
	@echo '     <winsock.h>'                                          >>$@
	@echo '  */'                                                      >>$@
	@echo '  #define XMLRPC_SOCKET SOCKET'                            >>$@
	@echo '  #define XMLRPC_HAVE_TIMEVAL 0'                           >>$@
	@echo '  #define XMLRPC_HAVE_TIMESPEC 0'                          >>$@
	@echo '  #define XMLRPC_HAVE_PTHREAD 0'                           >>$@
	@echo '  #define XMLRPC_HAVE_WINTHREAD 1'                         >>$@
	@echo '#else'                                                     >>$@
	@echo '  #define XMLRPC_SOCKET int'                               >>$@
	@echo '  #define XMLRPC_HAVE_TIMEVAL 1'                           >>$@
	@echo '  #define XMLRPC_HAVE_TIMESPEC 1'                          >>$@
	@echo '  #define XMLRPC_HAVE_PTHREAD 1'                           >>$@
	@echo '  #define XMLRPC_HAVE_WINTHREAD 0'                         >>$@
	@echo '#endif'                                                    >>$@
	@echo ''                                                          >>$@
	@echo '#if defined(_MSC_VER)'                                     >>$@
	@echo '  /* Newer MSVC has long long, but MSVC 6 does not */'     >>$@
	@echo '  #define XMLRPC_INT64 __int64'				  >>$@
	@echo '  #define XMLRPC_PRId64 "I64"'                             >>$@
	@echo '  #define XMLRPC_INT32 __int32'				  >>$@
	@echo '#else'							  >>$@
	@echo '  #define XMLRPC_INT64 long long'	                  >>$@
	@echo '  #define XMLRPC_PRId64 "lld"'                             >>$@
	@echo '  #define XMLRPC_INT32 int'		                  >>$@
	@echo '#endif'                                                    >>$@
	@echo '#endif'                                                    >>$@

$(BLDDIR)/$(SUBDIR)/xmlrpc-c:
	mkdir $@

COMPAT_LINK_CMDS = \
  $(LN_S) xmlrpc-c/oldxmlrpc.h         xmlrpc.h; \
  $(LN_S) xmlrpc-c/server.h            xmlrpc_server.h; \
  $(LN_S) xmlrpc-c/server_abyss.h      xmlrpc_abyss.h; \
  $(LN_S) xmlrpc-c/server_w32httpsys.h xmlrpc_server_w32httpsys.h; \

HEADERS_TO_INSTALL = \
  xmlrpc-c/config.h \
  xmlrpc-c/inttypes.h \
  xmlrpc-c/c_util.h \
  xmlrpc-c/util.h \
  xmlrpc-c/base.h \
  xmlrpc-c/json.h \
  xmlrpc-c/abyss.h \
  xmlrpc-c/abyss_unixsock.h \
  xmlrpc-c/abyss_winsock.h \
  xmlrpc-c/server.h \
  xmlrpc-c/server_abyss.h \
  xmlrpc-c/server_w32httpsys.h \
  xmlrpc-c/oldxmlrpc.h \

ifeq ($(ENABLE_CPLUSPLUS),yes)
  HEADERS_TO_INSTALL += \
    xmlrpc-c/oldcppwrapper.hpp \
    xmlrpc-c/girerr.hpp \
    xmlrpc-c/girmem.hpp \
    xmlrpc-c/base.hpp \
    xmlrpc-c/base64.hpp \
    xmlrpc-c/timeout.hpp \
    xmlrpc-c/xml.hpp \
    xmlrpc-c/registry.hpp \
    xmlrpc-c/server_abyss.hpp \
    xmlrpc-c/packetsocket.hpp \
    xmlrpc-c/server_pstream.hpp \

    COMPAT_LINK_CMDS += $(LN_S) xmlrpc-c/oldcppwrapper.hpp XmlRpcCpp.h;
endif

HEADERINST_PREFIX = /xmlrpc-c

ifeq ($(MUST_BUILD_CLIENT),yes)
  HEADERS_TO_INSTALL += \
    xmlrpc-c/client.h \
    xmlrpc-c/transport.h \
    xmlrpc-c/client_global.h \

  COMPAT_LINK_CMDS += $(LN_S) xmlrpc-c/client.h xmlrpc_client.h;

  ifeq ($(ENABLE_CPLUSPLUS),yes)
    HEADERS_TO_INSTALL += \
      xmlrpc-c/client.hpp \
      xmlrpc-c/client_transport.hpp \
      xmlrpc-c/client_simple.hpp \

  endif
endif
ifeq ($(ENABLE_CGI_SERVER),yes)
  HEADERS_TO_INSTALL += xmlrpc-c/server_cgi.h
  COMPAT_LINK_CMDS += $(LN_S) xmlrpc-c/server_cgi.h xmlrpc_cgi.h;
endif

default: all

all:

.PHONY: install-compat-hdr
install-compat-hdr: install-headers
# Install old names of header files for backward compatibility
	cd $(DESTDIR)$(HEADERINST_DIR); \
	  rm -f xmlrpc.h xmlrpc_client.h xmlrpc_server.h xmlrpc_cgi.h \
                xmlrpc_server_abyss.h xmlrpc_abyss.h \
		xmlrpc_server_w32httpsys.h \
	        XmlRpcCpp.h; \
	  $(COMPAT_LINK_CMDS)

.PHONY: install
install: install-common install-compat-hdr

.PHONY: clean
clean:
	rm -f xmlrpc-c/config.h

.PHONY: distclean
distclean: clean

.PHONY: check
check:

.PHONY: dep
dep:

OMIT_CONFIG_H_RULE = Y

include $(SRCDIR)/common.mk

=== tools/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  SRCDIR := $(call updir,$(CURDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := tools

include $(BLDDIR)/config.mk

SUBDIRS = \
  binmode-rpc-kit \
  lib \
  turbocharger \
  xml \

ifeq ($(MUST_BUILD_CLIENT),yes)
  SUBDIRS += xmlrpc xmlrpc_transport

  ifeq ($(ENABLE_CPLUSPLUS),yes)
    SUBDIRS += xml-rpc-api2cpp xml-rpc-api2txt xmlrpc_cpp_proxy

    ifeq ($(BUILD_XMLRPC_PSTREAM),yes)
      SUBDIRS += xmlrpc_pstream
    endif
  endif
endif

.PHONY: all clean distclean install check dep

all: $(SUBDIRS:%=%/all)

clean: $(SUBDIRS:%=%/clean)

distclean: $(SUBDIRS:%=%/distclean)

install: $(SUBDIRS:%=%/install)

check:

dep: $(SUBDIRS:%=%/dep)

include $(SRCDIR)/common.mk

=== lib/expat/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  LIBDIR := $(call updir,$(CURDIR))
  SRCDIR := $(call updir,$(LIBDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := lib/expat

include $(BLDDIR)/config.mk

# Build up SUBDIRS:
SUBDIRS = gennmtab xmlparse xmltok

default: all

.PHONY: all clean distclean tags distdir intall check dep

all: $(SUBDIRS:%=%/all)

# Extra dependencies to make parallel make work in spite of all the submakes
# (See top level make file for details)
xmlparse/all: gennmtab/all xmltok/all
xmltok/all: gennmtab/all

clean: $(SUBDIRS:%=%/clean) clean-common

distclean: $(SUBDIRS:%=%/distclean) distclean-common

tags: $(SUBDIRS:%=%/tags) TAGS

DISTFILES = 

distdir: distdir-common

install: $(SUBDIRS:%=%/install)

check:

dep: $(SUBDIRS:%=%/dep)

include $(SRCDIR)/common.mk

=== lib/libutil/Makefile ===
###############################################################################
# This directory builds libxmlrpc_util, which contains utility
# functions that are used by the Xmlprc-c libraries, and also
# directly by Xmlrpc-c programs.  Some of them are documented for use
# by Xmlrpc-c users, as facilities of the libxmlrpc library (which
# prerequires libxmlrpc_util).
#
# The functions in this library are characterized by being general purpose
# programming functions, such as one might wish were in the standard C
# library, which have nothing in particular to do with XML-RPC.
###############################################################################

ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  LIBDIR := $(call updir,$(CURDIR))
  SRCDIR := $(call updir,$(LIBDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := lib/libutil

include $(BLDDIR)/config.mk

default: all

TARGET_LIBRARY_NAMES := libxmlrpc_util

STATIC_LIBRARIES_TO_INSTALL = libxmlrpc_util.a

SHARED_LIBS_TO_BUILD := libxmlrpc_util
SHARED_LIBS_TO_INSTALL := libxmlrpc_util

TARGET_MODS = \
  asprintf \
  base64 \
  error \
  lock_platform \
  lock_pthread \
  lock_none \
  make_printable \
  memblock \
  select \
  sleep \
  string_number \
  time \
  utf8 \

OMIT_LIBXMLRPC_UTIL_RULE=Y
MAJ=3
  # Major number of shared libraries in this directory

include $(SRCDIR)/common.mk

INCLUDES = -I$(BLDDIR) -Isrcdir \
           -I$(BLDDIR)/include -Isrcdir/include -Isrcdir/lib/util/include

UTIL_SHLIB = $(call shlibfn,libxmlrpc_util)
#UTIL_SHLIB is e.g. libxmlrpc_util.so.3.1
UTIL_SHLIBLE = $(call shliblefn,libxmlrpc_util)
#UTIL_SHLIBLE is e.g. libxmlrpc_util.so

# This 'common.mk' dependency makes sure the symlinks get built before
# this make file is used for anything.

$(SRCDIR)/common.mk: srcdir blddir

.PHONY: all
all: libxmlrpc_util.a $(TARGET_SHARED_LIBRARIES) $(TARGET_SHARED_LE_LIBS)

# Rule for this is in common.mk, courtesy of TARGET_LIBRARY_NAMES:
$(UTIL_SHLIB): $(TARGET_MODS:%=%.osh)
$(UTIL_SHLIB): LIBOBJECTS = $(TARGET_MODS:%=%.osh)
$(UTIL_SHLIB): LIBDEP += -lpthread
ifeq ($(MSVCRT), yes)
    $(UTIL_SHLIB): LIBDEP += -lws2_32 -lwsock32
endif

# Rule for this is in common.mk, courtesy of TARGET_LIBRARY_NAMES:

libxmlrpc_util.a: $(TARGET_MODS:%=%.o)
libxmlrpc_util.a: LIBOBJECTS = $(TARGET_MODS:%=%.o)

#-----------------------------------------------------------------------------
#  RULES TO COMPILE OBJECT MODULES FOR LIBRARIES
#-----------------------------------------------------------------------------

# Rules to compile object modules from which to build the static and shared
# library are in common.mk, courtesy of TARGET_MODS.

.PHONY: install
install: install-common

.PHONY: clean distclean
clean: clean-common

distclean: clean distclean-common

.PHONY: dep
dep: dep-common

include depend.mk

=== lib/libwww_transport/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  LIBDIR := $(call updir,$(CURDIR))
  SRCDIR := $(call updir,$(LIBDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := lib/libwww_transport

include $(BLDDIR)/config.mk

default: all

.PHONY: all
all: xmlrpc_libwww_transport.o xmlrpc_libwww_transport.osh

# Rules for the above dependencies are in common.mk,
# courtesy of TARGET_MODS.

TARGET_MODS = xmlrpc_libwww_transport

OMIT_LIBWWW_TRANSPORT_RULE=Y

include $(SRCDIR)/common.mk

# This 'common.mk' dependency makes sure the symlinks get built before
# this make file is used for anything.

$(SRCDIR)/common.mk: srcdir blddir

LIBWWW_INCLUDES := $(shell libwww-config --cflags)

INCLUDES = \
  -I$(BLDDIR) \
  -I$(BLDDIR)/include \
  -Isrcdir/include \
  -Isrcdir/lib/util/include \
  $(LIBWWW_INCLUDES)

.PHONY: clean
clean: clean-common

.PHONY: distclean
distclean: clean distclean-common

.PHONY: tags
tags: TAGS

.PHONY: distdir
distdir:

.PHONY: install
install:

.PHONY: dep
dep: dep-common

include depend.mk

# Need this dependency for those who don't use depend.mk.
# Without it, version.h doesn't get created.
xmlrpc_libwww_transport.o xmlrpc_libwww_transport.osh: version.h

=== lib/util/Makefile ===
###############################################################################
# This directory builds object modules that provide utility functions that
# programs can use.  Not libraries, though -- just programs.  The reason
# we don't want any library to use object modules in here is that they'll
# probably pollute the name space when users link those libraries to their
# programs.  In fact, if more than one Xmlrpc-c library included one of these
# modules, the libraries would conflict with each other.
#
# So a utility function that is to be used by libraries (and, optionally,
# programs) should go in libxmlrpc_util.  libxmlrpc_util is a prerequisite
# for many Xmlrpc-c libraries, gets included in a program link only once,
# and uses external symbol names that have the "xmlrpc_" prefix to avoid
# collision with users' code.
#
# If we knew a portable way to link multiple object modules into one and
# restrict the symbols exported by the whole, we could avoid this mess and
# just link utility object modules into each Xmlrpc-c library.
##############################################################################

ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  LIBDIR := $(call updir,$(CURDIR))
  SRCDIR := $(call updir,$(LIBDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := lib/util

default: all

include $(BLDDIR)/config.mk

OMIT_UTILS_RULE = Y

include $(SRCDIR)/common.mk

# This 'common.mk' dependency makes sure the symlinks get built before
# this make file is used for anything.

$(SRCDIR)/common.mk: srcdir blddir

LIBOBJS = \
  casprintf.o \
  cmdline_parser.o \
  cmdline_parser_cpp.o \
  getoptx.o \
  string_parser.o \
  stripcaseeq.o \

.PHONY: all
all: $(LIBOBJS)

INCLUDES = -Isrcdir/$(SUBDIR)/include -I$(BLDDIR)

%.o:%.c
	$(CC) -c $(CFLAGS_ALL) $<

%.o:%.cpp
	$(CXX) -c $(CXXFLAGS_ALL) $<

include depend.mk

.PHONY: clean distclean
clean: clean-common

distclean: clean distclean-common

.PHONY: dep
dep: dep-common

install:

=== test/cpp/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  testDIR := $(call updir,$(CURDIR))
  SRCDIR := $(call updir,$(testDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := test/cpp

include $(BLDDIR)/config.mk

PROGS = test

default: all

all: $(PROGS)

XMLRPC_C_CONFIG = $(BLDDIR)/xmlrpc-c-config.test

LIBS := 

LIBS += -lpthread

INCLUDES = -Isrcdir/include -I$(BLDDIR) -Isrcdir -Isrcdir/lib/util/include

# This 'common.mk' dependency makes sure the symlinks get built before
# this make file is used for anything.

$(SRCDIR)/common.mk: srcdir blddir

include $(SRCDIR)/common.mk

TEST_OBJS = \
  test.o \
  base64.o \
  registry.o \
  server_abyss.o \
  server_pstream.o \
  tools.o \
  value.o \
  xml.o \

ifeq ($(MUST_BUILD_CLIENT),yes)
  TEST_OBJS += testclient.o
  CLIENT_LIBS = $(LIBXMLRPC_CLIENTPP_A) $(LIBXMLRPC_CLIENT_A)
  LIBS += $(shell $(XMLRPC_C_CONFIG) client --ldadd)
else
  TEST_OBJS += testclient_dummy.o
  CLIENT_LIBS =
endif


TEST_LIBS = \
  $(LIBXMLRPC_SERVER_ABYSSPP_A) \
  $(LIBXMLRPC_SERVER_PSTREAMPP_A) \
  $(LIBXMLRPC_SERVERPP_A) \
  $(CLIENT_LIBS) $(LIBXMLRPCPP_A) \
  $(LIBXMLRPC_CPP_A) \
  $(LIBXMLRPC_SERVER_ABYSS_A) \
  $(LIBXMLRPC_SERVER_A) \
  $(LIBXMLRPC_A) \
  $(LIBXMLRPC_ABYSS_A) \
  $(LIBXMLRPC_PACKETSOCKET_A) \
  $(LIBXMLRPC_UTIL_A) \

ifeq ($(MSVCRT),yes)
TEST_LIBS += socketpair.o
endif

ifneq ($(ENABLE_LIBXML2_BACKEND),yes)
  # We're using the internal Expat XML parser
  TEST_LIBS += $(LIBXMLRPC_XMLPARSE_A) $(LIBXMLRPC_XMLTOK_A)
  LIB_XML =
  registry.o: D_INTERNAL_EXPAT=-DINTERNAL_EXPAT
else
  LIB_XML = $(shell xml2-config --libs)
endif

test: $(TEST_OBJS) $(TEST_LIBS)
	$(CXXLD) -o $@ $(LDFLAGS_ALL) $^ $(LIB_XML) $(LIBS)

%.o:%.cpp
	$(CXX) -c $(INCLUDES) $(CXXFLAGS_ALL) $(D_INTERNAL_EXPAT) $<

socketpair.o: $(SRCDIR)/Windows/socketpair.cpp
	$(CXX) -c $(INCLUDES) $(CXXFLAGS_ALL) $(D_INTERNAL_EXPAT) $<

# Note the difference between 'check' and 'runtests'.  'check' means to check
# our own correctness.  'runtests' means to run the tests that check our
# parent's correctness

.PHONY: check
check:

.PHONY: runtests
runtests: test
	./test

.PHONY: install
install:

.PHONY: clean clean-local distclean
clean: clean-common clean-local
clean-local:
	rm -f $(PROGS)

distclean: clean distclean-common

.PHONY: dep
dep: dep-common

include depend.mk

=== tools/xml-rpc-api2cpp/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  TOOLSDIR := $(call updir,$(CURDIR))
  SRCDIR := $(call updir,$(TOOLSDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := tools/xml-rpc-api2cpp

default: all

include $(BLDDIR)/config.mk

PROGS := xml-rpc-api2cpp
PROGRAMS_TO_INSTALL := $(PROGS)
MAN_FILES_TO_INSTALL := xml-rpc-api2cpp.1

all: $(PROGS)

include $(SRCDIR)/tools/common.mk

# <sstream.h> in Glibc 2.2 has a bug that results in inlining failure,
# so we disable warnings for that:
CFLAGS_LOCAL = -Wno-inline

INCLUDES = -I$(BLDDIR) -I$(BLDDIR)/include -Isrcdir/include

ifeq ($(MSVCRT),yes)
  CLIENT_LDLIBS += -lws2_32 -lwsock32 -lpthread
endif

LDLIBS = -L$(BLDDIR)/src/cpp -lxmlrpc_cpp -L$(BLDDIR)/src -lxmlrpc_server \
  $(CLIENT_LDLIBS)

OBJECTS = \
  xml-rpc-api2cpp.o \
  DataType.o \
  XmlRpcFunction.o \
  XmlRpcClass.o \
  SystemProxy.o \

xml-rpc-api2cpp: \
  $(OBJECTS) \
  $(LIBXMLRPC_CPP) \
  $(CLIENT_LIBS_DEP) \
  $(LIBXMLRPC_SERVER) \
  $(LIBXMLRPC) \
  $(LIBXMLRPC_XML) \
  $(LIBXMLRPC_UTIL)
	$(CXXLD) -o $@ $(LDFLAGS_ALL) $(OBJECTS) $(LDLIBS)

%.o:%.cpp
	$(CXX) -c $(CXXFLAGS_ALL) $<

# This common.mk dependency makes sure the symlinks get built before
# this make file is used for anything.

$(SRCDIR)/tools/common.mk: srcdir blddir

include depend.mk

.PHONY: clean
clean: clean-common
	rm -f $(PROGS)

.PHONY: distclean
distclean: clean distclean-common

.PHONY: dep
dep: dep-common

=== tools/xml/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  TOOLSDIR := $(call updir,$(CURDIR))
  SRCDIR := $(call updir,$(TOOLSDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := tools/xml

default: all

include $(BLDDIR)/config.mk

PROGS := xmlrpc_parsecall

PROGRAMS_TO_INSTALL = $(PROGS)

include $(SRCDIR)/tools/common.mk

INCLUDES = \
  -I../lib/include \
  -Iblddir \
  -Iblddir/include \
  -Isrcdir/include \
  -Isrcdir/lib/util/include

all: $(PROGS)

UTIL_OBJS = \
  casprintf.o \

UTILS = $(UTIL_OBJS:%=$(UTIL_DIR)/%)

DUMPVALUE = blddir/tools/lib/dumpvalue.o

# Can we just use $(LIBS) in the link?

LIBS = $(LIBXMLRPC) $(LIBXMLRPC_XML) $(LIBXMLRPC_UTIL)

PARSECALL_OBJS = xmlrpc_parsecall.o $(DUMPVALUE)

xmlrpc_parsecall: $(PARSECALL_OBJS) $(LIBS) $(UTILS)
	$(CCLD) -o $@ $(LDFLAGS_ALL) $^

%.o:%.c $(BLDDIR)/include/xmlrpc-c/config.h
	$(CC) -c $(CFLAGS_ALL) $<

# This common.mk dependency makes sure the symlinks get built before
# this make file is used for anything.

$(SRCDIR)/tools/common.mk: srcdir blddir

include depend.mk

.PHONY: dep
dep: dep-common

.PHONY: clean
clean: clean-common
	rm -f $(PROGS)

.PHONY: distclean
distclean: clean distclean-common

=== tools/xmlrpc/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  TOOLSDIR := $(call updir,$(CURDIR))
  SRCDIR := $(call updir,$(TOOLSDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := tools/xmlrpc

default: all

include $(BLDDIR)/config.mk

PROGRAMS_TO_INSTALL = xmlrpc

include $(SRCDIR)/tools/common.mk

INCLUDES = \
  -I../lib/include \
  -Iblddir \
  -Iblddir/include \
  -Isrcdir/include \
  -Isrcdir/lib/util/include

all: xmlrpc

UTIL_OBJS = \
  casprintf.o \
  cmdline_parser.o \
  getoptx.o \
  stripcaseeq.o \
  string_parser.o \

UTILS = $(UTIL_OBJS:%=$(UTIL_DIR)/%)

DUMPVALUE = blddir/tools/lib/dumpvalue.o

XMLRPC_OBJS = xmlrpc.o $(DUMPVALUE)

ifeq ($(MSVCRT),yes)
  CLIENT_LDLIBS += -lws2_32 -lwsock32 -lpthread
endif

xmlrpc: $(XMLRPC_OBJS) $(CLIENT_LIBS_DEP) $(UTILS)
	$(CCLD) -o $@ $(LDFLAGS_ALL) $(XMLRPC_OBJS) $(UTILS) $(CLIENT_LDLIBS)

%.o:%.c $(BLDDIR)/include/xmlrpc-c/config.h
	$(CC) -c $(CFLAGS_ALL) $<

# This common.mk dependency makes sure the symlinks get built before
# this make file is used for anything.

$(SRCDIR)/tools/common.mk: srcdir blddir

include depend.mk

.PHONY: dep
dep: dep-common

.PHONY: clean
clean: clean-common
	rm -f xmlrpc

.PHONY: distclean
distclean: clean distclean-common

=== tools/xmlrpc_pstream/Makefile ===
ifeq ($(SRCDIR),)
  updir = $(shell echo $(dir $(1)) | sed 's/.$$//')
  TOOLSDIR := $(call updir,$(CURDIR))
  SRCDIR := $(call updir,$(TOOLSDIR))
  BLDDIR := $(SRCDIR)
endif
SUBDIR := tools/xmlrpc_pstream

READLINE_LDLIBS = -lreadline -lncurses

default: all

include $(BLDDIR)/config.mk

PROGRAMS_TO_INSTALL = xmlrpc_pstream

include $(SRCDIR)/tools/common.mk

INCLUDES = \
  -I../lib/include \
  -Isrcdir/lib/util/include \
  -Iblddir \
  -Iblddir/include \
  -Isrcdir/include \

all: xmlrpc_pstream

OBJECTS = \
  xmlrpc_pstream.o \
  blddir/tools/lib/dumpvalue.o \

LIBS = \
  $(LIBXMLRPC_CLIENTPP) \
  $(LIBXMLRPCPP) \
  $(CLIENT_LIBS_DEP) \
  $(LIBXMLRPC) \
  $(LIBXMLRPC_XML) \
  $(LIBXMLRPC_UTIL) \

LDLIBS = $(CLIENTPP_LDLIBS) $(CLIENT_LDLIBS) $(READLINE_LDLIBS)

UTIL_OBJS = \
  casprintf.o \
  cmdline_parser_cpp.o \
  cmdline_parser.o \
  getoptx.o \
  string_parser.o \
  stripcaseeq.o \

UTILS = $(UTIL_OBJS:%=$(UTIL_DIR)/%)

xmlrpc_pstream:  $(OBJECTS) $(LIBS) $(UTILS)
	$(CXXLD) -o $@ $(LDFLAGS_ALL) $(OBJECTS) $(UTILS) $(LDLIBS) $(LADD)

%.o:%.cpp blddir/include/xmlrpc-c/config.h
	$(CXX) -c $(CXXFLAGS_ALL) $<

# This common.mk dependency makes sure the symlinks get built before
# this make file is used for anything.

$(SRCDIR)/tools/common.mk: srcdir blddir

include depend.mk

.PHONY: clean
clean: clean-common
	rm -f xmlrpc_pstream

.PHONY: distclean
distclean: clean distclean-common

.PHONY: dep
dep: dep-common

=== debian/changelog ===
xmlrpc-c (1.33.14-9) unstable; urgency=medium

  * QA upload.
  * debian/control:
       - Added 'Rules-Requires-Root: no' to source stanza.
       - Bumped Standards Version to 4.5.0.
       - Changed VCS fields to Salsa.
  * debian/gbp.conf: changed master branch to debian/master.
  * debian/libxmlrpc-core-c3-dev.manpages: created to install manpage.
  * debian/manpage/*: created to add a manpage to xmlrpc.
  * debian/salsa-ci.yml: created to perform CI in Salsa.
  * debian/watch: updated. Wasn't working before.

 -- Carlos Henrique Lima Melara <charlesmelara@outlook.com>  Fri, 19 Jun 2020 18:31:22 -0300

xmlrpc-c (1.33.14-8) unstable; urgency=medium

  * QA upload.
  * Get rid of the recently added udeb package.  Closes: #874268
    It turned out that it has been broken already in Ubuntu several years
    ago already (with libcurl dropping its udeb), and nobody ever noticed
    it.  Now it's also broken in Debian as well…
    So, it's clear that this udeb isn't actually serving any good purpose.

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 04 Sep 2017 22:20:42 +0200

xmlrpc-c (1.33.14-7) unstable; urgency=medium

  * QA upload.
  * Upload to unstable.
  * debian/copyright: clarify a copyright/license statement.  Closes: #857456
  * Bump shlibs version of libxmlrpc-c++8v5 due to GCC-7 op mangling.
    Closes: #871290
  * debian/rules:
    + Don't explicitly use quilt, source format '3.0 (quilt)' implies it.
    + Stop manual update of config.{sub,guess}, nowadays
      dh_update_autotools_config takes care of it automatically.
    + Prefer `$(MAKE) -C tools` over `cd tools && make`
    + Leave the job of calling `make check` to dh_auto_test.
    + Move this removal due to license issues from clean (where it might be
      skipped) to configure.
    + Clean up the cleaning code.
    + Fix FTCBFS by passing BUILDTOOL_CC and BUILDTOOL_CCLD to make.
      Thanks to Helmut Grohne <helmut@subdivi.de> for the patch
      Closes: #874183
  * debian/control:
    + Bump Standards-Version to 4.1.0, no changes needed.
    + Don't start short description with an article
    + Drop build-dependency on quilt.
    + Run wrap-and-sort.

 -- Mattia Rizzolo <mattia@debian.org>  Mon, 04 Sep 2017 11:47:11 +0200

xmlrpc-c (1.33.14-6) experimental; urgency=medium

  * QA upload.
  * Add patch from Chris Lamb to make the build reproducible.  Closes: #860279

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 15 Apr 2017 00:00:19 +0200

xmlrpc-c (1.33.14-5) experimental; urgency=medium

  * QA upload.
  * Drop README.source, how a quilt package is handled is common knowledge now.
  * Drop the lintian override, it's a pedantic tag, I also doubt it's a FPO.
  * Add a udeb for libxmlrpc-core-c3.
    Change imported from Ubuntu.  See  LP: #831496 for the origin.
  * Move XmlRpcCpp.h from libxmlrpc-core-c3-dev to libxmlrpc-c++8-dev, as it's
    c++ stuff.  Closes: #644161

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 11 Mar 2017 00:38:27 +0100

xmlrpc-c (1.33.14-4) unstable; urgency=medium

  * QA upload.
  * Add patch fixing FTBFS on non-x86 architectures.

 -- Mattia Rizzolo <mattia@debian.org>  Fri, 10 Mar 2017 23:41:13 +0100

xmlrpc-c (1.33.14-3) unstable; urgency=medium

  * Upload to unstable. QA upload.
  * debian/libxmlrpc-core-c3-dev.doc-base created.
  * debian/libxmkrpc-c++8v5.install:
      - debian/lintian/libxmlrpc-c++8 entry removed.
      - debian/lintian/libxmlrpc-c++8v5 entry created.
  * debian/libxmlrpc-core-c3.install:
      - debian/lintian/libxmlrpc-core-c3 entry removed.
  * debian/lintian:
      - libxmlrpc-core-c3 removed.
      - libxmlrpc-c++8 removed.
      - libxmlrpc-c++8v5 created. (about hardening)
  * debian/source/format:
      3.0 (quilt)
  * debian/patches:
      - updated (blhc --all quiet now):
          - XXXFLAGS.patch
          - ldflag_lib_expat_gennmtab.patch
      - typo.patch created.
  * debian/watch:
      - with 'debian uupdate'.

 -- Herbert Parentes Fortes Neto <hpfn@debian.org>  Sat, 23 Jul 2016 13:10:10 -0300

xmlrpc-c (1.33.14-2) experimental; urgency=medium

  * QA upload.
  * debian/clean file created:
      - rm src/cpp/{blddir, srcdir}
  * debian/control:
      - bump Standards-Version from 3.9.6 to 3.9.8.
      - Vcs-* fields fixed.
      - Section entry from Package's statement removed. It duplicates the
        Section entry from Source's statement.
        from Source's statement.
  * debian/rules:
      - '-Wl,--as-needed' added to LDFLAGS.
  * debian/patches:
      - no_curl_test.patch to avoid testclient.cpp. FTBFS. (Closes: #831261)
      - ldflag_lib_expat_gennmtab.patch. hardening.
      - XXXFLAGS.patch. adds some hardening.
        (still 'hardening-no-pie' lintian)
  * debian/watch created.

 -- Herbert Parentes Fortes Neto <hpfn@debian.org>  Sat, 23 Jul 2016 10:31:02 -0300

xmlrpc-c (1.33.14-1) unstable; urgency=medium

  * QA upload.
  * Maintainer field set to QA Group.
  * Bump Standards-Version to 3.9.6.
  * Update FSF address in debian/copyright.

 -- Emanuele Rocca <ema@debian.org>  Sun, 13 Dec 2015 14:06:51 +0100

xmlrpc-c (1.33.14-0.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename library packages for g++ 5 transition (see #791313)

 -- Jonathan Wiltshire <jmw@debian.org>  Tue, 11 Aug 2015 22:31:41 +0100

xmlrpc-c (1.33.14-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Document missing license (Closes: #760377)
  * Clean unused code to prevent conflicting licenses
  * Add ${shlibs:Depends} to depends of xmlrpc-api-utils to prevent
    several missing dependencies (Thanks lintian)

 -- Paul Gevers <elbrus@debian.org>  Sat, 08 Nov 2014 20:53:51 +0100

xmlrpc-c (1.33.14-0.1) unstable; urgency=low

  * Non-maintainer upload.
  * New upstream release. (Closes: #660213)
  * Drop upstream patches, refresh others.
  * gbp.conf: Use upstream branch as the tree, and enable
    pristine-tar-commit.
  * control, *.install: Bump the C++ lib soname, update C lib minor.
  * xmlrpc-api-utils.*: Fix xml-rpc-api2txt paths.


=== debian/control ===
Source: xmlrpc-c
Priority: optional
Section: libs
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends:
 debhelper (>= 9),
 g++ (>= 4:7),
 libcurl4-openssl-dev | libcurl3-openssl-dev,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: http://xmlrpc-c.sourceforge.net
Vcs-Git: https://salsa.debian.org/debian/xmlrpc-c.git
Vcs-Browser: https://salsa.debian.org/debian/xmlrpc-c

Package: libxmlrpc-c++8-dev
Section: libdevel
Architecture: any
Depends:
 libc6-dev,
 libxmlrpc-c++8v5 (= ${binary:Version}),
 libxmlrpc-core-c3-dev (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 xmlrpc-api-utils,
Conflicts:
 libxmlrpc-c++4-dev,
Breaks:
 libxmlrpc-core-c3-dev (<< 1.33.14-5),
Replaces:
 libxmlrpc-core-c3-dev (<< 1.33.14-5),
Description: Lightweight RPC library based on XML and HTTP [C++ development libraries]
 XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
 It converts the procedure call into an XML document, sends it to a remote
 server using HTTP, and gets back the response as XML.
 .
 This library provides a modular implementation of XML-RPC for C++.
 .
 Install this package if you wish to develop your own programs using this
 library.

Package: libxmlrpc-c++8v5
Architecture: any
Depends:
 libxmlrpc-core-c3 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 libxmlrpc-c++8,
Replaces:
 libxmlrpc-c++8,
Description: Lightweight RPC library based on XML and HTTP [C++ runtime libraries]
 XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
 It converts the procedure call into an XML document, sends it to a remote
 server using HTTP, and gets back the response as XML.
 .
 This library provides a modular implementation of XML-RPC for C++.

Package: libxmlrpc-core-c3-dev
Section: libdevel
Architecture: any
Depends:
 libc6-dev,
 libxmlrpc-core-c3 (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 xmlrpc-api-utils,
Description: Lightweight RPC library based on XML and HTTP [C development libraries]
 XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
 It converts the procedure call into an XML document, sends it to a remote
 server using HTTP, and gets back the response as XML.
 .
 This library provides a modular implementation of XML-RPC for C.
 .
 Install this package if you wish to develop your own programs using this
 library.

Package: libxmlrpc-core-c3
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Lightweight RPC library based on XML and HTTP [C runtime libraries]
 XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
 It converts the procedure call into an XML document, sends it to a remote
 server using HTTP, and gets back the response as XML.
 .
 This library provides a modular implementation of XML-RPC for C.

Package: xmlrpc-api-utils
Conflicts:
 xml-rpc-api2cpp,
 xml-rpc-api2txt,
Provides:
 xml-rpc-api2cpp,
 xml-rpc-api2txt,
Replaces:
 xml-rpc-api2cpp,
 xml-rpc-api2txt,
Architecture: any
Section: devel
Depends:
 libc6-dev,
 libfrontier-rpc-perl,
 libxmlrpc-c++8v5 (= ${binary:Version}),
 libxmlrpc-core-c3 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Generate C++ wrapper classes for XML-RPC servers
 XML-RPC is a quick-and-easy way to make procedure calls over the Internet.
 It converts the procedure call into an XML document, sends it to a remote
 server using HTTP, and gets back the response as XML.
 .
 This package contains two programs:
  * xml-rpc-api2cpp, a utility for generating C++ wrapper classes based
    on an XML-RPC API, obtained by interrogating an XML-RPC server.
  * xml-rpc-api2txt, a utility for printing out an XML-RPC API as a
    text file.  The API is obtained by interrogating an XML-RPC server.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

override_dh_auto_configure:
	# Strip the following unused file from the tree to prevent it from being
	# used as the license is incompatible with lib/util/getoptx.*
	rm -fv tools/turbocharger/mod_gzip.c
	dh_auto_configure -- \
		--disable-libwww-client \
		--disable-wininet-client

override_dh_auto_build:
	dh_auto_build -- BUILDTOOL_CC=gcc 'BUILDTOOL_CCLD=$$(BUILDTOOL_CC)'
	$(MAKE) -C tools

override_dh_auto_clean:
	# Add here commands to clean up after the build process.
	# xxx upstream build process still breaks on distclean...
	[ ! -f Makefile ] || [ ! -f config.status ] || dh_auto_clean || true

override_dh_install:
	dh_install --fail-missing

override_dh_makeshlibs:
	dh_makeshlibs -plibxmlrpc-c++8v5 -V'libxmlrpc-c++8v5 (>= 1.33.14-7~)'
	dh_makeshlibs --remaining-packages

override_dh_compress:
	dh_compress -Xusr/share/doc/libxmlrpc-core-c3-dev/examples/

%:
	dh $@
